/******************************************************************************
  * @file    PT32x030x_ldac.h
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/12/29
  * @brief    This file contains all the functions prototypes for the LDAC firmware library
  *
  ******************************************************************************
  * @attention
  *
  *
  *****************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef PT32x030x_LDAC_H
#define PT32x030x_LDAC_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "PT32x030x.h"


/** @addtogroup LDAC
  * @{
  */

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/

/** @defgroup IS_LDAC_ALL_PERIPH 
  * @{
  */
#define IS_LDAC_ALL_PERIPH(SEL)            ((SEL) == LDAC)
/**
  * @}
  */
	
/** @defgroup IS_LDAC_Value 
  * @{
  */
#define IS_LDAC_Value(SEL)       				  ((SEL) <= 0x1F)
/**
  * @}
  */

/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */
void LDAC_SetData(LDAC_TypeDef* LDACx, u32 LDAC_Data);
void LDAC_Cmd(LDAC_TypeDef* LDACx, FunctionalState NewState);
	
/**
  * @}
  */
  
#ifdef __cplusplus
}
#endif

#endif

