/********************************************************************************
  * @file    PT32x030x_wdg.h
  * @author  Application development team
  * @version V1.0.0
  * @date    2022/12/29 
  * @brief   This file contains all the functions prototypes for the wdg firmware 
  *          library
  * @attention
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *******************************************************************************/
#ifndef PT32x030x_WDG_H
#define PT32x030x_WDG_H

#ifdef __cplusplus
 extern "C" {
#endif

#include "PT32x030x.h"

#define KR_KEY_DISABLE   		((u32)0xFFFFFFFF)

/** @defgroup WDG_ALL_PERIPH
* @{ 
*/
#define IS_WDG_ALL_PERIPH(SEL)     ((SEL) == IWDG)

/** @defgroup WDG_LockKey
* @{ 
*/
#define WDG_LockKey_Unlock  ((u32)0x1ACCE551)
#define WDG_LockKey_Lock    ((u32)0x00000000)
#define IS_WDG_LockKey(SEL)				 (((SEL) == WDG_LockKey_Unlock) || \
                                    ((SEL) == WDG_LockKey_Lock))

/** @defgroup WDG_FLAG
* @{ 
*/
typedef enum
{
	WDG_FLAG_HungryDog   = 0x00,
	WDG_FLAG_LockStatus,         	
}WDG_FLAG;
#define IS_WDG_FLAG(SEL)			 (((SEL) == WDG_FLAG_HungryDog) || \
                                ((SEL) == WDG_FLAG_LockStatus))

#define WDG_StatusBit       ((u32)0x00000001)        


/** @defgroup WDG_ReloadValue
* @{ 
*/
#define IS_WDG_ReloadValue(SEL) ((SEL) <= 0xFFFFFFFF)


/*! function declaration and definition*/
void WDG_LockConfig(WDG_TypeDef* WDGx, u32 WDG_WriteAccess);
FlagStatus WDG_GetLockStatus(WDG_TypeDef* WDGx);
void WDG_SetReload(WDG_TypeDef* WDGx, u32 Reload);
void WDG_ReloadCounter(WDG_TypeDef* WDGx);
void WDG_Cmd(WDG_TypeDef* WDGx, FunctionalState NewState);
FlagStatus WDG_GetFlagStatus(WDG_TypeDef* WDGx, WDG_FLAG Flag);
ITStatus WDG_GetITStatus(WDG_TypeDef* WDGx, u32 WDG_IT);
void WDG_ResetConfig(WDG_TypeDef* WDGx, FunctionalState NewState);
void WDG_DebugPendingConfig(WDG_TypeDef* WDGx, FunctionalState NewState);
  
#ifdef __cplusplus
}
#endif

#endif 






