/********************************************************************************
  * @file    PT32x030x_id.h
  * @author  Application development team
  * @version V1.0.0
  * @date    2022/12/29 
  * @brief   This file contains all the functions prototypes for the id firmware 
  *          library
  * @attention
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *******************************************************************************/

#include "PT32x030x_id.h"

/** @defgroup ID
  * @brief ID driver modules
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/


/**
  * @brief ID Get CustomerID
  * @retval ID->UDID
  */
u32 ID_GetCustomerID(void)
{
	return ( ID->UDID );
}

/**
  * @brief Get the unique ID
  * @param UID_Number:the value will be 1,2,3
  * @retval UID
  */
u32 ID_GetUID(u8 UID_Number)
{
	u32 UID;
	if(UID_Number==1)	UID=ID->UID1;
	else if(UID_Number==2)	UID=ID->UID2;
	else if(UID_Number==3)	UID=ID->UID3;
	else
	{
		UID=0;
	}
	return UID;
}

/**
  * @brief Get the chip ID
  * @retval ID->CID
  */
u32 ID_GetCID(void)
{
	return ( ID->CID );
}

/**
  * @}
  */
