/********************************************************************************
  * @file    PT32x030x_opa.h
  * @author  Application development team
  * @version V1.0.0
  * @date    2022/12/29 
  * @brief   This file contains all the functions prototypes for the opa firmware 
  *          library
  * @attention
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *******************************************************************************/

#include "PT32x030x_opa.h"

/** @defgroup OPA
  * @brief OPA driver modules
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/**
  * @brief OPA enable command
  * @param OPA_Num:OPA Number
  * @param NewState:FunctionalState type variable
  * @retval None
  */
void OPA_Cmd(u32 OPA_Num, FunctionalState NewState)
{
	/* Check the parameters */
	assert_param(IS_OPA_Number(OPA_Num));
	assert_param(IS_FUNCTIONAL_STATE(NewState));
    
	if (NewState != DISABLE)
	{
		if(OPA_Num == OPA0)
		{
				OPA->CR |= (u32)OPA_CR_OPA0E;
		}
		else
		{
				OPA->CR |= (u32)OPA_CR_OPA1E;
		}
	}
	else
	{
		if(OPA_Num == OPA0)
		{
				OPA->CR &= (u32)~((u32)OPA_CR_OPA0E);
		}
		else
		{
				OPA->CR &= (u32)~((u32)OPA_CR_OPA1E);
		}
	}
}

/**
  * @}
  */
