  /******************************************************************************
  * @Example PT32x030x_Timer_LED
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/12/29
  * @brief   ͨTIM2ʱжϣLEDÿ1˸һΣ
  *          
  ******************************************************************************
  * @attention	
  *										
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
	*
  *****************************************************************************/

#include "PT32x030x.h"

#define		LED_PORT	GPIOB
#define		LED_PIN		GPIO_Pin_0

#define		LED_OFF()	GPIO_SetBits(LED_PORT, LED_PIN)
#define		LED_ON()	GPIO_ResetBits(LED_PORT, LED_PIN)

/**
* @brief LEDGPIO
* @param 
* @retval 
*/
void LED_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;							//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Up;			//ƫ
	GPIO_InitStructure.GPIO_Pin = LED_PIN;						//ѡҪƵGPIO
	GPIO_Init(LED_PORT, &GPIO_InitStructure);					//ʼGPIO
	
	GPIO_SetBits(LED_PORT, LED_PIN);									//GPIO״̬
}

/**
* @brief TIM2ʽ
* @param 
* @retval 
*/
void TIM2_Int_Diver(void)
{
	NVIC_InitTypeDef NVIC_InitStruct;								//һNVIC_InitTypeDef͵Ľṹ
	TIM_TimeBaseInitTypeDef  TIM_TimeBaseInitStruct;//һNVIC_InitTypeDef͵Ľṹ
	
	TIM_TimeBaseInitStruct.TIM_Prescaler = 3600-1;										 //36M/3600=0.01MHZ
	TIM_TimeBaseInitStruct.TIM_AutoReload = 10000-1;									 //0.01MHZ*10000=1HZ
	TIM_TimeBaseInitStruct.TIM_Direction = TIM_Direction_Up;					 //ϼ
	TIM_TimeBaseInit(TIM2, &TIM_TimeBaseInitStruct);									 //ʼTIM2
	
	TIM_ITConfig(TIM2,TIM_IT_ARI,ENABLE);									//ʱжϳʼ
	
	NVIC_InitStruct.NVIC_IRQChannel=TIM2_IRQn;								//ʱжԴ
	NVIC_InitStruct.NVIC_IRQChannelPriority=0x00;							//жȼ
	NVIC_InitStruct.NVIC_IRQChannelCmd=ENABLE;								//ʹNVIC
	NVIC_Init(&NVIC_InitStruct);															//ʼNVIC	
	
	TIM_Cmd(TIM2, ENABLE);																		//TIM2
}

u8 TIM_IT_FLAG=0;
int main (void)
{
	LED_Driver();
	TIM2_Int_Diver();
	while(1)
	{		
		if(TIM_IT_FLAG)	//ȡ־Ƿ
		{
			LED_ON();
		}
		else
		{
			LED_OFF();
		}
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %lu\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %lu\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


