/******************************************************************************
  * @Example PT32x030x_EXTI
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/12/29
  * @brief   ͨذⲿжϹرհLED
  *          
  ******************************************************************************
  * @attention	
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x030x.h"

#define		LED_PORT		GPIOA
#define		LED_PIN		  GPIO_Pin_8

#define		LED_OFF()	GPIO_SetBits(LED_PORT, LED_PIN)
#define		LED_ON()	GPIO_ResetBits(LED_PORT, LED_PIN)

/**
* @brief LEDGPIO
* @param 
* @retval 
*/
void LED_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;							//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = LED_PIN;						//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Up;			//
	GPIO_Init(LED_PORT, &GPIO_InitStructure);					//ÿ⺯ʼGPIO
	
	GPIO_ResetBits(LED_PORT, LED_PIN);						//GPIO״̬
}

/**
* @brief ðж
* @param 
* @retval 
*/
void KEY_Int_Driver(void)
{
	NVIC_InitTypeDef NVIC_InitStruct;							//һNVIC_InitTypeDef͵Ľṹ
	GPIO_InitTypeDef GPIO_InitStructure;					//һGPIO_InitTypeDef͵Ľṹ
	
	/*ʼGPIO*/
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_In;	//ģʽΪ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Up;	//
	GPIO_Init(GPIOB, &GPIO_InitStructure);				//ÿ⺯ʼGPIO
	
	/*˿жϴѡ*/
	EXTI_TriggerTypeConfig(EXTIB,EXTI_Pin_8, EXTI_Trigger_RisingFalling);
	EXTI_ITConfig(EXTIB,EXTI_Pin_8,ENABLE);

	/*NVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = EXTIB_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
}

extern u8 PB_IntFlag;
int main (void)
{
	LED_Driver();
	KEY_Int_Driver();
	while(1)
	{
		if(PB_IntFlag)
		{
			GPIO_ReverseBits(LED_PORT, LED_PIN);
			PB_IntFlag=0;
		}
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


