/**
  ******************************************************************************
  * @file    PT32x030x_PWM
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/12/29
  * @brief   ͨʱ1ͨ1ͬռձȲLEDγɺ
   ******************************************************************************
  * @attention	
  *							
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics		
  *
  *****************************************************************************/
	
#include "PT32x030x.h"
#include "math.h"

/**
* @brief TIM1ĸ
* @param 
* @retval 
*/
void TIM_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_8, AFIO_AF_1,ENABLE);
}

/**
* @brief TIM1ʽ
* @param 
* @retval 
*/
void TIM_Mode_Config(void)
{
	PWM_TimeBaseInitTypeDef PWM_TimeBaseInitType;
	PWM_OCInitTypeDef OutInit;
	/* ʱѡ */
	PWM_TimeBaseInitType.PWM_InternalClockSource = PWM_InternalClockSource_PCLK;
	/* ģʽ --  */
	PWM_TimeBaseInitType.PWM_CenterAlignedMode = PWM_CenterAlignedMode_Disable;
	/* ģʽΪϼ */
	PWM_TimeBaseInitType.PWM_Direction = PWM_Direction_Up;
	/* ƥĴ,ۼMR0+1Ƶʺһ»ж */
	PWM_TimeBaseInitType.PWM_AutoReloadValue = 999;
	/* CNTʱ = Fcksys/(psc+1)*/
	PWM_TimeBaseInitType.PWM_Prescaler = 35;
	/* ʼTIM1*/
	PWM_TimeBaseInit(TIM1,&PWM_TimeBaseInitType);
	/* ΪPWMͨΪ1ͨ*/
	OutInit.PWM_Channel =PWM_Channel_1;
	/* ΪPWMģʽ */	
	OutInit.PWM_OCMode = TIM_OCMode_PWM1;
	/* ͻ */
	OutInit.PWM_OCNOutput = PWM_OCNOutput_Disable;		
	OutInit.PWM_OCOutput = PWM_OCOutput_Enable;  
	/* PWMʱƽ״̬ */	
	OutInit.PWM_OCIdleState = PWM_OCIdleState_Low;
	OutInit.PWM_OCNIdleState = PWM_OCNIdleState_Low;
	/* PWMռձ P = (PWM_OCValue+1) / (PWM_AutoReloadValue+1)*/	
	OutInit.PWM_OCValue = 0;
  /* PWMȽ*/	
	OutInit.PWM_OCPolarity = PWM_OCPolarity_High;
  OutInit.PWM_OCNPolarity = PWM_OCNPolarity_High;
	/* ʼPWM */
	PWM_OCInit(TIM1, &OutInit);
	/* ʹPWM */
	PWM_Cmd(TIM1,ENABLE);
}

/**
* @brief ʱ
* @param 
* @retval 
*/
void Delay(uint32_t delay)
{
	while(delay > 0)
		delay--;
}

/**
* @brief PWMռձȺ
* @param duty:ʱװֵ
* @retval 
*/
void Set_Pwm_Duty(uint16_t duty)
{
	if(duty >= TIM1->ARR)
		duty = (TIM1->ARR -1);
	TIM1->OCR1 = duty;
}

int main()
{
	u16 duty = 0;

	/*TIM1*/
	TIM_GPIO_Config();
	TIM_Mode_Config();

	while(1)
	{
		Delay(10000);
		Set_Pwm_Duty(duty);
		duty ++;
		if(duty >= 999) duty = 0;
	}
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/

