/******************************************************************************
  * @Example PT32x030x_IWDG
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/12/29
  * @brief   1IWDGĿλͨڴӡȴι䣻
  *			     ״ζNMI_HandlerжϣڲιҲжϱ־
  *          ڶζIWDGλٴͨڴӡ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλУ
  *							
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics	
  *
  *****************************************************************************/
#include "PT32x030x.h"

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_0,ENABLE);	//PA2 TX
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_0,ENABLE);	//PA3 RX
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity = UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_ParityMode_Even;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief IWDG
* @param 
* @retval 
*/
void IWDG_Driver(u32 rlv)
{	
	WDG_LockConfig(IWDG, WDG_LockKey_Unlock);	//IWDGĴ
	WDG_SetReload(IWDG, rlv);				//װؼĴֵ
	WDG_ReloadCounter(IWDG);				//ι(ؼ)
  WDG_ResetConfig(IWDG, ENABLE);			//Źλʹ
	WDG_Cmd(IWDG, ENABLE);					//ʹIWDG
	WDG_LockConfig(IWDG, WDG_LockKey_Lock);	//סIWDGĴ
}

/**
* @brief IWDGι
* @param 
* @retval 
*/
void IWDG_Feed(void)
{
	WDG_LockConfig(IWDG, WDG_LockKey_Unlock);	//IWDGĴ
	WDG_ReloadCounter(IWDG);				//ι(ؼ)
	WDG_LockConfig(IWDG, WDG_LockKey_Lock);	//סIWDGĴ	
}

int main (void)
{
	UART_Driver();
	IWDG_Driver(32768);	//timeout=1s	
	printf("ȴιȡιϢϵͳλظ\r\n");
	while(1)
	{
		IWDG_Feed();//ι
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


