  /******************************************************************************
  * @Example PT32x030x_IFMC
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/12/29
  * @brief   ͨ򣬶ȡƬIFMCַָڵ5ֵ,״򴮿ڴӡ"Flashд",
	*          ¼״У򴮿ڴӡ"״УFlashδд"дֵFlash
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλnoУ
  *		
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  *****************************************************************************/

#include "PT32x030x.h"

#define WRITE_START_ADDR  ((u32)0x00007200)	
#define WRITE_END_ADDR    ((u32)0x000073FF)	// 1Kbyte


u32 IFMC_Data[5]={	0x3211ABC1,
                    0x4210DCBA,
                    0x5210ABCD,
                    0x6210DCBA,
                    0x7210ABCD};

u8 flash_ok=0;
                    
/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_0,ENABLE);	//PA2 TX0
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_0,ENABLE);	//PA3 RX0
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity = UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_ParityMode_Even;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief Flash״̬
* @param 
* @retval 
*/
void check_flash(void)
{
	u32 Address = 0;		//ȡַ
	u8 Count_Write=0;	//ȡ
	u8 error_count=0;
	/* дǷȷ */
	Address = WRITE_START_ADDR;
	while((Count_Write < 5))
	{
		if((*(__IO u32*) Address) != IFMC_Data[Count_Write])	//ǰֵַ0x3210ABCD
		{
			error_count++;
		}
		Address += 4;
		Count_Write++;
	}
	if(error_count==0)
	{
		printf("Flashд\r\n");
		flash_ok=1;
	}
	if(error_count>0)
	{		
		printf("״УFlashδд\r\n");
		flash_ok=0;
	}
}

/**
* @brief Flash
* @param 
* @retval 
*/
void Flash_Erase(void)
{
	u32 EraseCounter = 0x00;	//ҪĿ
	u32 NbrOfPage = 0x00;	//
	IFMC_Status IFMCStatus = IFMC_Complete; 	//FlashĽ
	
	/* Ҫٿ(1=512Byte) */
	NbrOfPage = ((WRITE_END_ADDR - WRITE_START_ADDR)+1) / IFMC_PAGE_SIZE;  //+1
	
	/* б־λ */
	IFMC_ClearFlag(IFMC_FLAG_WC | IFMC_FLAG_PEC | IFMC_FLAG_CEC | IFMC_FLAG_CERR | IFMC_FLAG_KERR | IFMC_FLAG_AERR);	//б־λ
	
	/* */
	for(EraseCounter = 0; (EraseCounter < NbrOfPage) && (IFMCStatus == IFMC_Complete); EraseCounter++)
	{
		IFMCStatus = IFMC_ErasePage(WRITE_START_ADDR + (IFMC_PAGE_SIZE * EraseCounter));
	}
}

/**
* @brief Flashд
* @param 
* @retval 
*/
void Flash_Write_WordCode(void)
{
	IFMC_Status IFMCStatus = IFMC_Complete; 	//FlashĽ
	u32 Address = 0;		//дַ
	u8 Count_Write=0;	//д

	__disable_irq();	/*ȫж*/
	
	Flash_Erase();
	
	Address = WRITE_START_ADDR;
	while((Count_Write < 5) && (IFMCStatus == IFMC_Complete))	//
	{
		IFMCStatus = IFMC_ProgramWord(Address, IFMC_Data[Count_Write]);
		Address = Address + 4;	//Flashд4ByteΪλ
		Count_Write++;
	}
	__enable_irq();    /*ȫж*/
}

/**
* @brief FLASH
* @param 
* @retval 
*/
void Flash_Read_WordCode()
{
	u32 Rx_Buffer[5];
	u32 Address = 0;																//ȡַ	
	u8 Count_Write=0;																//ȡ
	u32 tmpreg = 0;
	Address = WRITE_START_ADDR;
	tmpreg = IFMC->CR;
	tmpreg &= ~ (0x000010F);
	tmpreg |= (IFMC_MainCodeKey & (~IFMC_WriteOperation));
	IFMC->CR = tmpreg;																//IFMC->CR
//	Flash_Erase();	
	while((Count_Write < 5) && !(IFMC->SR&IFMC_FLAG_BSY))							//BUSY״̬
	{
		Rx_Buffer[Count_Write] = IFMC_ReadWord(Address);							//ýӿڶ
		printf("Ϊ%#lx--ַ%lx\r\n",Rx_Buffer[Count_Write],Address);
		Address = Address + 4;	
		Count_Write++;		
	}
		printf("ڲFLASH\r\n");
}

int main (void)
{
	UART_Driver();
	check_flash();
	if(flash_ok==0)
	{
		Flash_Write_WordCode();
		printf("successed to flash\r\n");
		check_flash();
	}
	printf("ʼڲFLASH\r\n");
	Flash_Read_WordCode();
	printf("*********************************************\r\n");
	while(1);
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


