/******************************************************************************
  * @Example PT32x030x_DMA/01_DMA_SPI
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/12/29
  * @brief   DMAͨ1ͨ赽ڴ洫佫SPI0_RXݴ䵽SPI0_VALУͨڴӡɺSPI0_VAL
  *          
  ******************************************************************************
  * @attention	Ϊ96001ʼλ8λ1λֹͣλżУ
  *             ʹø:
  *							SPI_MISOSPI_MOSI̽PA6PA7ػշ
  *							PA4 --> SPI_CS
  *							PA5 --> SPI_SCK
  *							PA6 --> SPI_MISO
  *							PA7 --> SPI_MOSI
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *****************************************************************************/

#include "PT32x030x.h"

u16 SPI0_VAL[10] = {0};
u16 SPI0_TX_Buf[10] = {1,2,3,4,5,6,7,8,9,10};

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_0,ENABLE);	//PA2 TX0
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_0,ENABLE);	//PA3 RX0
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity = UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_ParityMode_Even;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief DMAģʽ
* @param 
* @retval 
*/
void DMA_Mode_Config(void)
{
	DMA_InitTypeDef DMA_InitStruct;
	NVIC_InitTypeDef NVIC_InitStruct;

	DMA_InitStruct.DMA_SourceBaseAddress = (u32)&SPI0->DR;       //Դַ
	DMA_InitStruct.DMA_DestinationBaseAddress = (u32)SPI0_VAL;        //Ŀĵַ
	DMA_InitStruct.DMA_NumberOfData = 10;                         //Ҫݵ
	DMA_InitStruct.DMA_SourceDataSize = DMA_SourceDataSize_Half;           //ԴDMAĴݿ
	DMA_InitStruct.DMA_DestinationDataSize = DMA_DestinationDataSize_Half;           //DMAĿĵصĴݿ
	DMA_InitStruct.DMA_SourceAddressIncrement = DMA_SourceAddressIncrement_Disable;                 //DMAԴַʹ
	DMA_InitStruct.DMA_DestinationAddressIncrement = DMA_DestinationAddressIncrement_Enable;                  //DMAĿĵַ
	DMA_InitStruct.DMA_Direction = DMA_Direction_PeripheralToMemory;         //䷽
	DMA_InitStruct.DMA_CircularMode = DMA_CircularMode_Disable;

	DMA_Init(DMA1,&DMA_InitStruct);

	DMA_PeripheralConfig(DMA1,DMA_ChannelxPERIPH_SPI0RX);                  //SPI0_RX

	DMA_ITConfig(DMA_IT_TC1E,ENABLE);                        //DMAͨ1ݴжʹ

	NVIC_InitStruct.NVIC_IRQChannel = DMA_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);

	DMA_Cmd(DMA1,ENABLE);                                    //ʹ
}

/**
* @brief DMAжϷ
* @param 
* @retval 
*/
void DMA_Handler(void)
{
	u8 i = 0;
	if(DMA_GetFlagStatus(DMA_FLAG_TC1F))
	{
		DMA_ClearITFlag(DMA_FLAG_TC1F);
		for(i=0;i<10;i++)
		{
			printf("SPI0_VAL[%d] = %d\r\n",i,SPI0_VAL[i]);
		}
		DMA_Cmd(DMA1,DISABLE);
	}
}

/**
* @brief SPIĸ
* @param 
* @retval 
*/
void SPI_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_4, AFIO_AF_0,ENABLE);	//SPI_CSֹܸ
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//SPI_SCKֹܸ
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//SPI_MISOֹܸ
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_7, AFIO_AF_0,ENABLE);	//SPI_MOSIֹܸ
}

/**
* @brief SPIĹģʽ
* @param 
* @retval 
*/
void SPI_MasterMode_Config(SPI_TypeDef* SPIx)
{
	SPI_InitTypeDef  SPI_InitStructure;						    //һSPI_InitTypeDef͵Ľṹ
	SPI_DMAInitTypeDef  SPI_DMAInitStructure;
	SPI_StructInit(&SPI_InitStructure);						    //ʹĬֵʼSPI_InitStructure

	/* SPI ģʽ */
	SPI_InitStructure.SPI_MasterSlaveMode = SPI_MasterSlaveMode_Master;		        //Ϊģʽ
	SPI_InitStructure.SPI_DataFrameFormat = SPI_DataFrameFormat_8b;		    //֡
	SPI_InitStructure.SPI_ClockPolarity = SPI_ClockPolarity_High;				    //ʱӼԣ״̬ʱSCKָߵƽ
	SPI_InitStructure.SPI_ClockPhase = SPI_ClockPhase_2Edge;			    //ʱλݲӵڶʱӱؿʼ
	SPI_InitStructure.SPI_CSS = SPI_CSS_SoftwareControl;				    //CSƣĬϳʼֵΪߵƽ
	SPI_InitStructure.SPI_Prescaler = 0;					    //SPIʱӷƵϵ
	SPI_InitStructure.SPI_BaudRate = 16;			    //SPIԤƵ f(sck)=f(pclk)/(SPI_Prescaler*(1+SPI_Prescaler))

	SPI_Init(SPIx, &SPI_InitStructure);						    //ʼSPI
	SPI_SoftwareControlCSSConfig(SPIx, SPI_SoftwareControlCSS_High);//ƬѡźſƣCSߵƽ


	SPI_DMAInitStructure.SPI_RxDMARequest = SPI_RxDMARequest_Enable;//DMAʹ
	SPI_DMAInitStructure.SPI_TxDMARequest = SPI_TxDMARequest_Disable;
	SPI_DMAInitStructure.SPI_DMATrigger = SPI_DMATrigger_1Frame;
	SPI_DMATransferInit(SPIx,&SPI_DMAInitStructure);

	SPI_Cmd(SPIx, ENABLE);									    //ʹSPI
}

/**
* @brief SPI
* @param 
* @retval 
*/
void SPI_Driver(void)
{
	SPI_GPIO_Config();
	SPI_MasterMode_Config(SPI0);
}

/**
* @brief SPIͺ
* @param 
* @retval 
*/
void SPI_Device(void)
{
	u8 i = 0;
	for(i=0;i<10;i++)
	{
		SPI0->DR = SPI0_TX_Buf[i];
	}
}

int main(void)
{  
  /*UART*/
	UART_Driver();
	/*DMA*/
	DMA_Mode_Config();
	/*SPI*/
	SPI_Driver();
	SPI_Device();
	while(1)
	{
	} 
	
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
