/******************************************************************************
  * @Example PT32x030x_DMA/02_DMA_M2M
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/12/29
  * @brief   DMAͨ1ͨڴ浽ڴ洫佫DMA_TX_BUFݴ䵽DMA_RX_BUFУͨڴӡɺDMA_RX_BUF
  *          
  ******************************************************************************
  * @attention	Ϊ96001ʼλ8λ1λֹͣλżУ
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
	*
  *****************************************************************************/
	
#include "PT32x030x.h"

u16 DMA_TX_BUF[10] = {1,2,3,4,5,6,7,8,9,10};
u16 DMA_RX_BUF[10] = {0};

/**
* @brief DMAģʽ
* @param 
* @retval 
*/
void DMA_Mode_Config(void)
{
	DMA_InitTypeDef DMA_InitStruct;
	NVIC_InitTypeDef NVIC_InitStruct;

	DMA_StructInit(&DMA_InitStruct);

	DMA_InitStruct.DMA_SourceBaseAddress = (uint32_t)DMA_TX_BUF;//Դַ
	DMA_InitStruct.DMA_DestinationBaseAddress = (uint32_t)DMA_RX_BUF;//Ŀĵַ
	DMA_InitStruct.DMA_NumberOfData = 10;//Ҫݵ
	DMA_InitStruct.DMA_SourceDataSize = DMA_SourceDataSize_Half;//ԴDMAĴݿ
	DMA_InitStruct.DMA_DestinationDataSize = DMA_DestinationDataSize_Half;//DMAĿĵصĴݿ
	DMA_InitStruct.DMA_SourceAddressIncrement = DMA_SourceAddressIncrement_Enable;//DMAԴַ
	DMA_InitStruct.DMA_DestinationAddressIncrement = DMA_DestinationAddressIncrement_Enable;//DMAĿĵַ
	DMA_InitStruct.DMA_Direction = DMA_Direction_MemoryToMemory;//䷽
	DMA_InitStruct.DMA_CircularMode = DMA_CircularMode_Disable;//ѭģʽ

	DMA_Init(DMA1,&DMA_InitStruct);

	DMA_ITConfig(DMA_IT_TC1E,ENABLE);//ʹDMAͨ1ݴж

	NVIC_InitStruct.NVIC_IRQChannel = DMA_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);

	DMA_Cmd(DMA1,ENABLE);//ʹ
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_0,ENABLE);	//PA2 TX0
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_0,ENABLE);	//PA3 RX0
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity = UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_ParityMode_Even;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief DMAжϷ
* @param 
* @retval 
*/
void DMA_Handler(void)
{
	uint8_t i = 0;
	if(DMA_GetFlagStatus(DMA_FLAG_TC1F))
	{
		DMA_ClearITFlag(DMA_FLAG_TC1F);
		for(i=0;i<10;i++)
		{
			printf("DMA_RX_BUF[%d] = %d\r\n",i,DMA_RX_BUF[i]);
		}
		DMA_Cmd(DMA1,DISABLE);
	}
}

int main (void)
{
	/*UART*/
  UART_Driver();
  /*DMA*/
	DMA_Mode_Config();
	while(1)
	{
	}  
	
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
