/**
  ******************************************************************************
  * @file    system_PT32x030x.c
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/12/29
  * @brief
  ******************************************************************************
  * @attention
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ,
  * Pai-ICκֱӣ ӻ̷𺦸
  *
  * (C) ȨPai-IC Microelectronics
  ******************************************************************************
  */


/* Includes ------------------------------------------------------------------*/
#include "PT32x030x.h"


/** @addtogroup PT32x03x_StdPeriph_Driver
  * @{
  */


/** @addtogroup CLK
  * @{
  */


/** @defgroup CLK_Private_Defines
  * @{
  */

/**
  * @}
  */
void Wait_ClockReady(void)
{
	u8 i, j;
	for(i = 0; i < 100; i++)
		for(j = 0; j < 48; j++);
}



//<<< Use Configuration Wizard in Context Menu >>>
/*--------------------- Clock Configuration ----------------------------------
//
//    <h> HSI(36M)
//      <q0>    ʹ
//                <i> Ĭ = ENABLE
//    </h>
//
//    <h> HSE(4~25M)
//      <e1>    ʹ
//                <i> Ĭ = DISABLE
//        <o2>  ⲿʱԴ
//                <0=> ⲿپ 
//                <1=> ʱ
//      </e>
//    </h>
//
//    <h> PLL
//      <e3>    PLLʹ
//                <i> Ĭ  = DISABLE
//        <o4>  PLLʱԴ
//                <0=> HSI
//                <1=> HSE
//                <2=> LSI
//                <i> ĬPLLʱԴ = HSI
//                <i> PLLʱƵ = Source clock * 2
//      </e>
//    </h>
//
//    <h> ϵͳʱ(HS_CLK)
//      <o5>    ϵͳʱԴ
//                <0=> HSI
//                <1=> HSE
//                <2=> PLL
//                <3=> LSI
//                <i> ĬϵͳʱԴ = HSI
//      <o6>  HCLKƵ
//                <i> ĬֵΪ0(Ƶ = 1)
//                <i> дֵΧ0-31(ӦƵ1-32)
//      <o7>  PCLKƵ
//                <i> ĬֵΪ0(Ƶ = 1)
//                <i> дֵΧ0-31(ӦƵ1-32)
//    </h>
//
//    <h> IFMC 
//      <o8>   Flash ȴ
//                <0=> 0 WS
//                <1=> 1 WS
//                <2=> 2 WS
//                <i> 0 WS:  1 KHz <= HCLK <= 24 MHz
//                <i> 1 WS: 24 MHz <  HCLK <= 48 MHz
//                <i> 2 WS: 48 MHz <  HCLK <= 72 MHz
//    </h>
//
//    <h>  MCO
//      <e9>    MCOʹ
//                <i> Ĭ = DISABLE
//        <o10>    MCOʱԴ
//                <0=> HSI
//                <1=> HSE
//                <2=> PLL
//                <3=> LSI
//                <4=> SYS_CLK
//        <o11>    MCO
//                <0=> PA8
//                <1=> PA9
//                <2=> PB2
//        <o12>   MCOƵ
//                <0=> 1
//                <1=> 2
//                <2=> 4
//                <3=> 8
//                <4=> 16
//    </e>
//    </h>
//
//    <o13>ǰHSEƵ
//    <i>Default: 24000000 (Unit:Hz)
//    <0-100000000>
*/


/** @defgroup CLK_Private_Defines
  * @{
  */

#define IOSC_36M_ENABLE	(1)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define EOSC_CLK_ENABLE	(0)     /*!< 0: DISABLE,  1: ENABLE      */
#define EOSC_CLK_SRC  (0)       /*!< 0: CRYSTAL,  1: EOSC_CLK 																						*/
#define PLL_CLK_ENABLE	(0)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define PLL_CLK_SRC	(1)   /*!< 0: IOCS_36M, 1: EOSC_CLK    2:IOSC_32K                               */
#define HCLK_SRC	(0)     /*!< 0: IOCS_36M, 1: EOSC_CLK    2:FD_CLK     3:IOSC_32K          */
#define HCLK_DIV	(0)     /*!< 0-31: DIV1-32       */
#define PCLK_DIV	(0)     /*!< 0-31: DIV1-32       */
#define WAIT_STATE	(1)   /*!< 0: 0 WS,     1: 1 WS,   2: 2 WS,                                     */
#define MCO_ENABLE	(0)   /*!< 0: DISABLE,  1: ENABLE                                               */
#define MCO_SRC		(4)     /*!< 0: IOCS_36M, 1: EOSC_CLK    2:FD_CLK     3:IOSC_32K       4:SYS_CLK    */
#define MCO_PINSEL	(1)   /*!< 0: PA8,      1: PA9,    2: PB2                                            */
#define MCO_DIV		(4)     /*!< 0: DIV1,     1: DIV2,   2: DIV4,   3: DIV8,   4: DIV16							    */
#define MCU_SYSTICK_FREQUENCE (36000000)


#define  IOSC_RC36M_VALUE     36000000UL
#define  I0SC_32K_VALUE       32768UL

/**
  * @}
  */

/** @defgroup CLK_Private_Functions
  * @{
  */

/**
* @brief ʱԴ
* @param IOSC_36M_ENABLE	ָ,ƬRC36Mʱʹܿ
* @param EOSC_CLK_ENABLE	ָ,ⲿƵʱʹܿ
* @retval None
*/
void CLOCK_Cmd(void)
{
#if (EOSC_CLK_ENABLE == 1)
	#if (EOSC_CLK_SRC==0)
		GPIO_DigitalRemapConfig(AFIOF, GPIO_Pin_0, AFIO_AF_0, ENABLE);
		GPIO_DigitalRemapConfig(AFIOF, GPIO_Pin_1, AFIO_AF_0, ENABLE);
		RCC_ClockSourceConfig(RCC_ClockSource_HSE, ENABLE);
	#else
		RCC_ClockSourceConfig(RCC_ClockSource_HSEExternal, ENABLE);
	#endif
#else
	RCC_ClockSourceConfig(RCC_ClockSource_HSE, DISABLE);
#endif

#if (IOSC_36M_ENABLE == 1)
	RCC_ClockSourceConfig(RCC_ClockSource_HSI, ENABLE);	//ʹڲRC 36M
#else
	RCC_ClockSourceConfig(RCC_ClockSource_HSI, DISABLE);	//رڲRC 36M
#endif
}

/**
* @brief ʱԴ໷
* @param PLL_CLK_ENABLE		ָ,໷ʹ
* @param PLL_CLK_SRC			ָ,
*     @arg 0: ƵʱԴѡڲRC 36M
*     @arg 1: ƵʱԴѡⲿʱ
*     @arg 2: ƵʱԴѡڲRC 32K
* @retval None
*/
void CLOCK_PLLConfig(void)
{
#if (PLL_CLK_ENABLE == 1)
	RCC_ClockSourceConfig(RCC_ClockSource_PLL, DISABLE);
	#if (PLL_CLK_SRC == 0 )
		#if (IOSC_36M_ENABLE == 0)
			#error "PLL_CLK ʱԴIOSC_36M δʹ "
		#else
			RCC_PLLClockSourceConfig(RCC_PLLClockSource_HSI);
		#endif
	#endif
	
	#if (PLL_CLK_SRC == 1 )
		#if (EOSC_CLK_ENABLE == 0)
			#error "PLL_CLK ʱԴEOSC_CLK δʹ"
		#else
			RCC_PLLClockSourceConfig(RCC_PLLClockSource_HSE);
		#endif
	#endif
	
	#if (PLL_CLK_SRC == 2 )
		RCC_PLLClockSourceConfig(RCC_PLLClockSource_LSI);
	#endif
	
	RCC_ClockSourceConfig(RCC_ClockSource_PLL, ENABLE);
#else
	RCC_ClockSourceConfig(RCC_ClockSource_PLL, DISABLE);
#endif
}

/**
* @brief IFMCȡָ
* @param None
* @retval None
*/
void IFMC_WaitConfig(void)
{
	IFMC ->CR = ((0xADEB0000) | (WAIT_STATE << 5)) ;
}

/**
* @brief ϵͳʱ
* @param HCLK_SRC		ָ,
*     @arg 0: ʱԴѡڲRC36M
*     @arg 1: ʱԴѡⲿʱ
*     @arg 2: ʱԴѡڲPLLƵʱ
*     @arg 3: ʱԴѡڲƵʱ
* @param HCLK_DIV		ָ,HCLKķƵϵ
* @param PCLK_DIV		ָ,PCLKķƵϵ
* @retval None
*/
void CLOCK_SystemClockConfig(void)
{
	#if (HCLK_SRC == 0 )
		#if (IOSC_36M_ENABLE == 0)
			#error "ϵͳʱԴIOSC_36M δʹ"
		#else
			RCC_SetSystemClock(RCC_SystemClock_HSI);
		#endif
	#endif
	
	#if (HCLK_SRC == 1 )
		#if (EOSC_CLK_ENABLE == 0)
			#error "ϵͳʱԴEOSC_CLK δʹ"
		#else
			Wait_ClockReady();
			RCC_SetSystemClock(RCC_SystemClock_HSE);
			//ʱӰȫƴ
			if (IOSC_36M_ENABLE == 0)	RCC_ClockSourceConfig(RCC_ClockSource_HSI, DISABLE);	//رڲRC 36M
		#endif
	#endif
	
	#if (HCLK_SRC == 2 )
		#if (PLL_CLK_ENABLE == 0)
			#error "ϵͳʱԴPLL_CLK δʹ"
		#else
			RCC_SetSystemClock(RCC_SystemClock_PLL);
			if(PLL_CLK_SRC != 2) Wait_ClockReady();
			//ʱӰȫƴ
			if(IOSC_36M_ENABLE == 0) RCC_ClockSourceConfig(RCC_ClockSource_HSI, DISABLE);	//رڲRC 36M
		#endif
	#endif
	
	#if (HCLK_SRC == 3 )
		RCC_SetSystemClock(RCC_SystemClock_LSI, ENABLE);	//ڲƵʱʹ
		//ʱӰȫƴ
		if(IOSC_36M_ENABLE == 0) RCC_ClockSourceConfig(RCC_ClockSource_LSI, DISABLE);	//رڲRC 36M
	#endif
	
	RCC_HCLKSetPrescaler(HCLK_DIV);	//HCLKƵѡ
	RCC_PCLKSetPrescaler(PCLK_DIV);	//PCLKƵѡ
	if((RCC_GetSystemClockSelection()) != HCLK_SRC)	//ϵͳʱѡ
	{
		while(1);
	}
	RCC_SetSystemClockAfterWakeUp(RCC_SystemClockAfterWakeUp_PreviousClock);
}

/**
* @brief ϵͳʱ
* @param MCO_ENABLE	ָ,ϵͳʱʹ
* @param MCO_PINSEL		ָ,
*     @arg 0: ϵͳʱPA8
*     @arg 1: ϵͳʱPD1
* @param MCO_DIV		ϵͳʱķƵ
* @retval None
*/
void CLOCK_MCOConfig(void)
{
	#if (MCO_ENABLE == 1)
		#if (MCO_SRC == 0 )
			#if (IOSC_36M_ENABLE == 0)
				#error "ϵͳʱԴIOSC_36M δʹ"
			#else
				RCC_SetMCOSource(RCC_ClockOutput_HSI);
			#endif
		#endif
		
		#if (MCO_SRC == 1 )
			#if (EOSC_CLK_ENABLE == 0)
				#error "ϵͳʱԴEOSC_CLK δʹ"
			#else
				RCC_SetMCOSource(RCC_ClockOutput_HSE);
			#endif
		#endif
		
		#if (MCO_SRC == 2 )
			#if (PLL_CLK_ENABLE == 0)
				#error "ϵͳʱԴPLL_CLK δʹ"
			#else
				RCC_SetMCOSource(RCC_ClockOutput_PLL);
			#endif
		#endif
		
		#if (MCO_SRC == 3 )
			RCC_ClockSourceConfig(RCC_ClockSource_LSI, ENABLE);	//ڲƵʱʹ
			RCC_SetMCOSource(RCC_ClockOutput_LSI);
		#endif
		
		#if (MCO_SRC == 4 )
			RCC_SetMCOSource(RCC_ClockOutput_SYS);
		#endif
		
		#if (MCO_PINSEL == 0)
			GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_8, AFIO_AF_0, ENABLE);
		#endif
		
		#if (MCO_PINSEL == 1)
			GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_9, AFIO_AF_5, ENABLE);
		#endif
		
		#if (MCO_PINSEL == 2)
			GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_2, AFIO_AF_1, ENABLE);
		#endif
		
		RCC_MCOSetPrescaler(MCO_DIV);
	#endif
}

/**
* @brief ȡϵͳʱ
* @param None
* @retval None
*/
u32 clk_get_sysclk(void)
{
	u32 SystemCoreClock;
	switch(HCLK_SRC)
	{
		case 0:
			SystemCoreClock = IOSC_RC36M_VALUE;
			break;
		case 1:
			SystemCoreClock = MCU_SYSTICK_FREQUENCE;
			break;
		case 2:
			if(PLL_CLK_SRC == 0)
			{
				SystemCoreClock = IOSC_RC36M_VALUE * 2;
			}
			else if(PLL_CLK_SRC == 1)
			{
				SystemCoreClock = MCU_SYSTICK_FREQUENCE * 2;
			}
			else if(PLL_CLK_SRC == 2)
			{
				SystemCoreClock = I0SC_32K_VALUE * 2;
			}
			else
			{
				;
			}
			break;
		case 3:
			SystemCoreClock = I0SC_32K_VALUE;
			break;
		
		default:
			break;
	}
	return SystemCoreClock;
}

/**
* @brief ϵͳʱӳʼ
* @param None
* @retval None
*/
void SystemInit (void)
{
	/* ʱʹ */
	CLOCK_Cmd();
	/* Ƶʱ */
	CLOCK_PLLConfig();
	/* Flash ȴ */
	IFMC_WaitConfig();
	/* ϵͳʱѡ */
	CLOCK_SystemClockConfig();
	/* ϵͳʱ */
	CLOCK_MCOConfig();
}

//<<< end of configuration section >>>

/**
  * @}
  */


/**
  * @}
  */


/**
  * @}
  */


/******************* (C) Ȩ Pai-IC Microelectronics *****END OF FILE****/

