/******************************************************************************
  * @Example PT32x030x_CMP
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/12/29
  * @brief   ȽCOMP1ĸΪLDACɵ0.5VddѹΪPF6ͨʱɵķ룬
	*          COMP1_OUT(PB4)PF6Եź,ػ½أRGBƻ˸
  *          
  ******************************************************************************
  * @attention	ʹø̣ҪDemoPF6PA15(CMP0_P0)̽
  *							
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x030x.h"

/**
* @brief ʱ
* @param 
* @retval 
*/
void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/**
* @brief PWM
* @param 
* @retval 
*/
void Software_PWM_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;							//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;					//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_NoPull;	//ƫ
	GPIO_Init(GPIOF, &GPIO_InitStructure);						//ÿ⺯ʼGPIO
}

/**
* @brief PWM
* @param 
* @retval 
*/
void Software_PWM_Run(void)
{
		static u8 count_temp=0;
		count_temp++;
		if(count_temp==1)		//
		{
			GPIO_SetBits(GPIOF, GPIO_Pin_6);
		}
		if(count_temp==2)		//½
		{
			count_temp=0;
			GPIO_ResetBits(GPIOF, GPIO_Pin_6);
		}
}

/**
* @brief COMP
* @param 
* @retval 
*/
void COMP_GPIO_Config(void)
{	
	GPIO_AnalogRemapConfig(AFIOB, GPIO_Pin_3,ENABLE); 		//CMP0_Nͨ	
	GPIO_AnalogRemapConfig(AFIOA, GPIO_Pin_15,ENABLE); 	//CMP0_P0ͨ	
	GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_4, AFIO_AF_5,ENABLE);	//ΪCMP0_OUTͨ	
}

/**
* @brief COMPʽ
* @param 
* @retval 
*/
void COMP_Int_Config(void)
{
	CMP_InitTypeDef CMP_InitStruct;
	
	CMP_StructInit(&CMP_InitStruct);
	CMP_InitStruct.CMP_NegativeInput = CMP_NegativeInput_LDAC;
	CMP_InitStruct.CMP_DigitalFilter = CMP_DigitalFilter_None;
	CMP_InitStruct.CMP_PowerMode = CMP_PowerMode_HighSpeed;
	CMP_InitStruct.CMP_OutputPolarity = CMP_OutputPolarity_Normal;
	CMP_InitStruct.CMP_Hysteresis = CMP_Hysteresis_Disable;
	CMP_InitStruct.CMP_PositiveInput= CMP_PositiveInput_CMPxP0;
	CMP_Init(CMP0,&CMP_InitStruct);

	CMP_Cmd(CMP0,ENABLE);
	
	CMP_ITConfig(CMP0,CMP_IT_COF,ENABLE);
	CMP_ITConfig(CMP0,CMP_IT_COR,ENABLE);
	NVIC_EnableIRQ(CMP0_IRQn);
	
	LDAC_SetData(LDAC,0x10);

	LDAC_Cmd(LDAC,ENABLE);	
}

/**
* @brief COMP
* @param 
* @retval 
*/
void COMP_Driver(void)
{
	COMP_GPIO_Config();
	COMP_Int_Config();
}

/**
* @brief LED
* @param 
* @retval 
*/
void LED_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;	//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;	//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_NoPull;	//ƫ
	GPIO_Init(GPIOB, &GPIO_InitStructure);	//ÿ⺯ʼGPIO
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
	GPIO_Init(GPIOF, &GPIO_InitStructure);	//ÿ⺯ʼGPIO
	
	GPIO_SetBits(GPIOB, GPIO_Pin_0);			//ÿ⺯GPIO״̬
	GPIO_SetBits(GPIOF, GPIO_Pin_2);			//ÿ⺯GPIO״̬
}

int main (void)
{
	Software_PWM_Driver();
	LED_Driver();
	COMP_Driver();
	while(1)
	{
		Software_Delay();
		Software_Delay();
		Software_PWM_Run();
		Software_Delay();
		Software_Delay();
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


