/******************************************************************************
  * @Example PT32x030x_SPI
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/12/29
  * @brief   ʹSPIԷգʹôϢ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλУ
  *				ʹø:
  *							
  *							SPI_MISOSPI_MOSI̽PA6PA7ػշ
  *							PA4 --> SPI_CS
  *							PA5 --> SPI_SCK
  *							PA6 --> SPI_MISO
  *							PA7 --> SPI_MOSI
	*
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
	*
  *****************************************************************************/
	
#include "PT32x030x.h"

/**
* @brief ʱ
* @param 
* @retval 
*/
void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_2, AFIO_AF_0,ENABLE);	//PA2 TX0
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_0,ENABLE);	//PA3 RX0
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity = UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_ParityMode_Even;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief SPIĸ
* @param 
* @retval 
*/
void SPI_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_4, AFIO_AF_0,ENABLE);	//SPI_CSֹܸ
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//SPI_SCKֹܸ
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//SPI_MISOֹܸ
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_7, AFIO_AF_0,ENABLE);	//SPI_MOSIֹܸ
}

/**
* @brief SPIĹģʽ
* @param 
* @retval 
*/
void SPI_MasterMode_Config(SPI_TypeDef* SPIx)
{
	SPI_InitTypeDef  SPI_InitStructure;						    //һSPI_InitTypeDef͵Ľṹ

	SPI_StructInit(&SPI_InitStructure);						    //ʹĬֵʼSPI_InitStructure
	
	/* SPI ģʽ */
	SPI_InitStructure.SPI_MasterSlaveMode = SPI_MasterSlaveMode_Master;		        //Ϊģʽ
	SPI_InitStructure.SPI_DataFrameFormat = SPI_DataFrameFormat_8b;		    //֡
	SPI_InitStructure.SPI_ClockPolarity = SPI_ClockPolarity_High;				    //ʱӼԣ״̬ʱSCKָߵƽ
	SPI_InitStructure.SPI_ClockPhase = SPI_ClockPhase_2Edge;			    //ʱλݲӵڶʱӱؿʼ
	SPI_InitStructure.SPI_CSS = SPI_CSS_SoftwareControl;				    //CSƣĬϳʼֵΪߵƽ
	SPI_InitStructure.SPI_Prescaler = 0;					    //SPIʱӷƵϵ
	SPI_InitStructure.SPI_BaudRate = 16;			    //SPIԤƵ f(sck)=f(pclk)/(SPI_PrescalerValue*(1+SPI_PrescalerValue))
    
	SPI_Init(SPIx, &SPI_InitStructure);						    //ʼSPI
	SPI_SoftwareControlCSSConfig(SPIx, SPI_SoftwareControlCSS_High);//ƬѡźſƣCSߵƽ
	
	SPI_Cmd(SPIx, ENABLE);									    //ʹSPI
}

/**
* @brief SPI
* @param 
* @retval 
*/
void SPI_Driver(void)
{
	SPI_GPIO_Config();
	SPI_MasterMode_Config(SPI0);
}

int main (void)
{
	u8 i = 0;
	u8 tx_data[5]={1,2,3,4,5};
	u8 rx_data[5]={0};
	/*UART*/
	UART_Driver();
	/*SPI*/
	SPI_Driver();
	while(i<5)
	{
		while(!SPI_GetFlagStatus(SPI0,SPI_FLAG_TXE));	        //FIFOΪ
		SPI_SendData(SPI0,tx_data[i]);
		while(!SPI_GetFlagStatus(SPI0,SPI_FLAG_RXNE));	        //FIFOǿ
		rx_data[i] = SPI_ReceiveData(SPI0);			
		i++;
	}
	i=0;
	while(i<5)
	{
		Software_Delay();
		printf("rx_data[%d] = %d \r\n",i,rx_data[i]);		
		i++;
	}	
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
